use Term::ReadLine;
use Net::LDAP;
use AddressBook;

$| = 1;
$term = new Term::ReadLine 'convert default schema';

print "Binding to new ldap server base....";
$new_ldap = AddressBook->new(source=>LDAP,config_file=>"./AddressBook.conf");
print "ok\n";
$choice = $term->readline("Do you want to migrate LDAP entries from the old ldap-abook default schema\n to the new schema? [y/n]");
if ($choice =~ /^y/i) {$migrate=1}
else {$migrate=0}
if ($migrate) {
  print "Binding to old ldap server base....";
  $old_ldap = AddressBook->new(source=>"old_ldap-abook",config=>$new_ldap->{config});
  print "ok\n";
}

print "New ldap base is: " . $new_ldap->{base} ."\n";
print "checking to see if server contains \'" . $new_ldap->{base} . "\'...";
@base_components = split ",",$new_ldap->{base};
$filter = "(&";
foreach $component (@base_components) {
  $filter .= "(" . $component . ")";
}
$filter .= ")";
$mesg = $new_ldap->{ldap}->search(base=>$new_ldap->{base},filter=>$filter);
$count = $mesg->count;
if ($count >= 1) {print "found.\n"}
else {
  print "not found.\n";
  $choice = $term->readline("Do you wish to add an entry for \'". $new_ldap->{base} . "\'? [y/n]");
  foreach $component (@base_components) {
    ($attribute,$value) = split "=",$component;
    if ($attribute eq "ou") {push @{$attr{objectclass}}, "organizationalUnit"}
    elsif ($attribute eq "dc") {push @{$attr{objectclass}}, "dcObject"}
    elsif ($attribute eq "o") {push @{$attr{objectclass}}, "organization"}
    else {die "Cannot determine appropriate objectclass for \'$attribute\'"}
    push @{$attr{$attribute}}, $value;
  }
  print "Adding an $objectclass entry for \'" . $new_ldap->{base} . "\'...";
  $result = $new_ldap->{ldap}->add($new_ldap->{base},attrs=>[%attr]);
  if ($result->code) {
    print "failed\n";
    print "failed to add entry: ",$result->error, "\n";
  } else {print "ok\n"}
}

if ($migrate) {
  print "Migrating entries to new ldap base & schema";
  $count = 0;
  while ($entry = $old_ldap->read) {
    $new_ldap->add($entry) || die "\nError adding entry: ",$new_ldap->code,"\n";
    $count++;
    print ".";
  }
  print "\n";
  print "$count entries were written to new ldap base\n";
}
